import axios from "axios";

axios.defaults.xsrfCookieName = 'csrftoken';
axios.defaults.xsrfHeaderName = 'X-CSRFToken';
axios.defaults.withCredentials = true;
/**
 * return the token from response
 *
 * @param {Response} response - The reponse
*/

class Client
{
    /**
     * Create a client to interract with the api
     *
     * @param {string} url - The url of the backend
    */

    constructor(url)
    {
        /**
         * The axios client
         * @type AxiosInstance */
        this.client = axios.create({
            baseURL: url,
            headers: {
                'Content-Type': 'application/json'
            }    
        });
    }

    /**
     * return if the client is logged
    */
    get isAuthentificate()
    {
        return this.token != undefined;
    }

    /**
     * A no consummer function to send get requests
     *
     * @param {string} uri - The path want to get
    */
    async _get(uri)
    {
        let response = await this.client.get(uri);
        return response;
    }

    /**
     * A no consummer function to send post requests
     *
     * @param {string} uri - The path want to post
    */
    async _post(uri, data)
    {
        /**
         * The axios client
         * @type AxiosInstance */
        console.log(data)
        let response = await this.client.post(uri, data)
        console.log(response.status)
        return response;
    }

    /**
     * Login your client with username and password
     *
     * @param {string} username - The username of the client
     * @param {string} password - The password of the client
    */
    async login(username, password)
    {
        let response = this._post(accounts_login, {username: username, password: password})
        return response;
    }
}

import {accounts_login} from "./urls.js"

let url = "http://0.0.0.0:8000/"

let client = new Client(url)

let response = await client.login("bozoman", "man")

export {Client}